########################################################################
# On CentOS/RHEL, if the Software Configurations Library is installed
# and Python 2.7 is installed, then it is used. This is only available
# on CentOS 6.5 for the x86_64 architecture, at this time.
########################################################################
%define __SCL   %(if [ -d /opt/rh/python27 ]; then echo 1; else echo 0; fi)

%if 0%{?__SCL} > 0
        %define PYTHON     python27
        %define python_sitelib_old_1 %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(plat_specific=False)")
        %define python_sitelib_old_2 %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(plat_specific=True)")
        %define python_sitelib %(echo python -c '"from distutils.sysconfig import get_python_lib; print get_python_lib(plat_specific=False)"' | scl enable python27 -)
        %define _SCL_base %(echo $(dirname $(dirname `echo which python | scl enable python27 -`)))
        %define _bindir %(dirname `echo which python | scl enable python27 -`)
        %define _datadir %{_SCL_base}/share
        %define _mandir %{_datadir}/man
        %define _docdir %{_datadir}/doc
        %define  __os_install_post      \
            /usr/lib/rpm/redhat/brp-compress; \
            %{!?__debug_package:/usr/lib/rpm/redhat/brp-strip %{__strip}}; \
            /usr/lib/rpm/redhat/brp-strip-static-archive %{__strip}; \
            /usr/lib/rpm/redhat/brp-strip-comment-note %{__strip} %{__objdump}; \
            echo /usr/lib/rpm/brp-python-bytecompile python27 | scl enable %{PYTHON} - ; \
            /usr/lib/rpm/redhat/brp-python-hardlink; \
            %{!?__jar_repack:/usr/lib/rpm/redhat/brp-java-repack-jars}
%else
        %define python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(plat_specific=False)")
%endif

%define	_PYTHON %(basename %{__python})

Name:           shellbags
Version:        0.5.5
Release:        1%{?dist}
Group:          Development/Libraries/Python
Summary:        Cross-platform shellbag parser
License:        Apache 2.0
URL:            http://www.williballenthin.com/forensics/shellbags/index.html
Source:		%{name}-%{version}.tar.gz
Patch1:		%{name}-%{version}-patch-001
%if 0%{?__SCL} > 0
BuildRequires:  python27-python-setuptools
Requires:       python27-python-setuptools
%else
BuildRequires:  python(abi) => 2.7
BuildRequires:	%{_PYTHON}-devel
Requires:	%{_PYTHON}
%endif
Requires:	python-registry
Requires:	python-enum
BuildArch:	noarch

%description
Microsoft Windows uses a set of Registry keys known as "shellbags"
to maintain the size, view, icon, and position of a folder when using
Explorer. These keys are useful to a forensic investigator. Shellbags
persist information for directories even after the directory is removed,
which means that they can be used to enumerate past mounted volumes,
deleted files, and user actions. Yuandong Zhu, Pavel Gladyshev, and Joshua
James provided a nice overview of the investigative value of shellbags in
"Using shellbag information to reconstruct user activities" [pdf]; however,
they do not describe how to programmatically access the data. Allan S Hay
went into greater detail in his December, 2004 document "MiTeC Registry
Analyser" [pdf], although he also leaves out a thorough analysis of the
format. TZWorks provides an effective closed-source shellbag parser sbag,
but does not explain its algorithm. Yogesh Khatri first described the basic
structure of Windows Shell Items in his blog post for 42 LLC entitled Shell BAG
Format Analysis. Joachim Metz went on to described the binary format of the
Windows Shell Item structures with great detail in Windows Shell Item format
specification [pdf]. This page documents an approach to parsing shellbags in
detail, as well as introduces an open-source, cross-platform shellbag parser.

%prep
%setup 
%patch1 -p1
########################################################################
# The system script that computes dependencies misidentifies the 
# python 2.7 dependency, so it is necessary to remove it from the
# dependency determination. 
########################################################################
%if 0%{?__SCL} > 0
cat > /tmp//pythondeps.sh << \EOF
#!/bin/sh
%{__python_requires} $* | sed -e 's/python(abi) = 2.7/python27-python(abi) = 2.7/'
EOF
chmod +x /tmp/pythondeps.sh
%define __python_requires /tmp/pythondeps.sh
%endif

%build
%if 0%{?__SCL} > 0
        echo python setup.py build | scl enable python27 -
%else
        %{__python} setup.py build
%endif

%install
%if 0%{?__SCL} > 0
        echo python setup.py install --root=$RPM_BUILD_ROOT | scl enable python27 -
%else
	%{__python} setup.py install --root=$RPM_BUILD_ROOT
%endif
mv $RPM_BUILD_ROOT/%{_bindir}/%{name}.py  $RPM_BUILD_ROOT/%{_bindir}/%{name}

%clean
%{__rm} -rf $RPM_BUILD_ROOT

%files
%doc LICENSE.TXT README.txt
%attr(0755, root, root)		%{_bindir}/shellbags
%attr(444, bin, bin)		%{python_sitelib}/%{name}-%{version}-py*.egg-info
%attr(644, root, root)		%{python_sitelib}/%{name}/*.py*

%changelog -n shellbags
* Fri Dec 20 2013 Willi Ballenthin <willi.ballenthin@gmail.com> 0.5.5-1
* Release 0.5.5.1
	Initial release

* Wed Jan 4 2012 Willi Ballenthin <willi.ballenthin@gmail.com> 0.5.1-2
* Release 0.5.1-2
	Initial release
